<template>
    <div :class="openShowModal ? 'openCatalog menu menu_xxl' : 'defaultCatalog menu menu_xxl'">
        <div class="modal-title">
            <h5>{{ $t('Add') }}</h5>
            <button uk-icon="close" @click="$emit('openModal')" />
        </div>

        <form @submit.prevent="onSubmit">
            <div class="modal-body">
                <div class="flex items-center gap-2">
                    <div class="w-1/2">
                        <div class="flex items-center gap-4 mb-4">
                            <div class="w-full">
                                <label for="form-stacked-text">{{ $t('name') }} RU</label>
                                <div class="uk-form-controls">
                                    <input class="form-input" id="form-stacked-text" type="text">
                                </div>
                            </div>

                            <div class="w-full">
                                <label for="form-stacked-text">{{ $t('name') }} UZ</label>
                                <div class="uk-form-controls">
                                    <input class="form-input" id="form-stacked-text" type="text">
                                </div>
                            </div>
                        </div>

                        <div class="flex items-center gap-4 mb-4">
                            <div class="w-full">
                                <label for="status">
                                    {{ $t('Categories') }}
                                    <v-select id="status" :options="books" label="title" class="!rounded-md mt-1"
                                        :placeholder="$t('Categories')" />
                                </label>
                            </div>

                            <div class="w-full">
                                <label for="form-stacked-text">{{ $t('Brand') }}</label>
                                <div class="uk-form-controls">
                                    <input class="form-input" id="form-stacked-text" type="text">
                                </div>
                            </div>
                        </div>

                        <div class="w-full mb-4">
                            <label for="status">
                                {{ $t('Phone') }}
                                <v-select id="status" :options="books" label="title" class="!rounded-md mt-1"
                                    :placeholder="$t('Phone')" />
                            </label>
                        </div>

                        <div class="w-full mb-4">
                            <div class="flex items-center gap-4 mb-4" v-for="(item, index) in items" :key="index">
                                <div class="w-1/2">
                                    <label for="form-stacked-text">{{ $t('Social networks') }}</label>
                                    <div class="uk-form-controls">
                                        <input class="form-input" id="form-stacked-text" type="text" v-model="item.title">
                                    </div>
                                </div>

                                <div class="w-1/2">
                                    <label for="form-stacked-text">{{ $t('Link') }}</label>
                                    <div class="uk-form-controls">
                                        <input class="form-input" id="form-stacked-text" type="text" v-model="item.link">
                                    </div>
                                </div>

                                <!-- <div class="w-1/6"> -->
                                <button class="btn-danger btn-action mt-6" @click="removeItem(index)">
                                    <span uk-icon="trash"></span>
                                </button>
                                <!-- </div> -->
                            </div>

                            <button class="btn-primary w-full" @click="repeateAgain">
                                <span uk-icon="plus"></span>
                            </button>
                        </div>

                        <div class="w-full">
                            <label for="form-stacked-text">{{ $t('Address') }}</label>
                            <div class="uk-form-controls">
                                <textarea class="form-input" rows="6"></textarea>
                            </div>
                        </div>
                    </div>


                    <div class="w-1/2">
                        <!-- Place of map -->
                        <div class="w-full">
                            <div id="map1"></div>
                        </div>

                        <div class="flex items-center gap-4 mb-4">
                            <div class="w-full">
                                <label for="form-stacked-text">{{ $t('Lat') }}</label>
                                <div class="uk-form-controls">
                                    <input class="form-input" id="form-stacked-text" type="text" v-model="location.lat">
                                </div>
                            </div>

                            <div class="w-full">
                                <label for="form-stacked-text">{{ $t('Lng') }}</label>
                                <div class="uk-form-controls">
                                    <input class="form-input" id="form-stacked-text" type="text" v-model="location.lng">
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>

            <div class="modal-footer">
                <button @click="$emit('openModal')" class="btn-danger">
                    Отменить
                </button>
                <button type="submit" class="btn-primary" @click="$emit('openModal')">
                    Сохранить
                </button>
            </div>
        </form>
    </div>
    <div :class="openShowModal ? 'black__shadow' : ''" />
</template>

<script setup>
import { ref, reactive, watch } from "vue";
import '@/assets/modal.css'
import L from "leaflet";
import "leaflet/dist/leaflet.css";

const props = defineProps({
    openShowModal: {
        type: Boolean,
        default: () => false
    },
})
const emit = defineEmits(['refresh', 'openModal'])
let nextTodoId = ref(2);
const product = ref('')

function removeItem(index) {
    items.splice(index, 1);
}

function repeateAgain() {
    items.push({
        id: nextTodoId.value++,
        title: "",
        link: "",
    });
}

const items = reactive([
    {
        id: 1,
        title: "",
        link: "",
    },
]);

let location = ref({
    lat: 0,
    lng: 0,
});

const onSubmit = async () => {

}

watch(() => props.openShowModal, function () {

    setTimeout(() => {
        var map = L.map("map1").setView([41.2995, 69.2401], 11);
        L.tileLayer("https://tile.openstreetmap.org/{z}/{x}/{y}.png", {
            attribution:
                '&copy; <a href="http://www.openstreetmap.org/copyright">OpenStreetMap</a>',
        }).addTo(map);

        var marker = L.marker(location.value).addTo(map);

        map.on("click", function (e) {
            location.value = e.latlng;

            // marker.remove();

            // L.marker().clearLayers();

            if (marker) {
                map.removeLayer(marker);
            }
            marker = L.marker(location.value).addTo(map);
        });
    }, 1000);

    if (props.openShowModal || props.modalValue?.id) {

        // product.value = JSON.parse(JSON.stringify(props.modalValue))
    } else {
        product.value = ''
    }
},
    { deep: true }
);
</script>


<style>
.menu_xxl {
    width: 1165px !important;
}

#map1 {
    height: 400px;
}
</style>
